//--------------------------------------------------------------------------------------
// File: BasicCompute11.hlsl
//
// This file contains the Compute Shader to perform array A + array B
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
//--------------------------------------------------------------------------------------

struct BufType
{
    int i; 
    float f;
};

StructuredBuffer<BufType> Buffer0;
StructuredBuffer<BufType> Buffer1;
RWStructuredBuffer<BufType> BufferOut;

[numthreads(1, 1, 1)]
void CSMain( uint3 DTid : SV_DispatchThreadID )
{
    BufferOut[DTid.x].i = Buffer0[DTid.x].i + Buffer1[DTid.x].i;
    BufferOut[DTid.x].f = Buffer0[DTid.x].f + Buffer1[DTid.x].f;
}

technique11 t0 
{ 
	pass p0
	{
		SetComputeShader(CompileShader(cs_5_0, CSMain())); 
	}
}